﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
Private Sub Class_Globals
	Dim CAPPLOG As Boolean 		= True						' Flag setting logging on / off
	Private fx As JFX
	Private frm As Form
	Dim DatePicker As JFXtrasDatePicker
	Dim DateField As JFXtrasDateTextField
	Dim TimeField As JFXtrasTimeTextField
	Private cfdimasterbtn As Button
	Dim CFDIDATA As String 	= "cfdidatabase.db"			' SQL database holding the tables (contacts)
	Dim CDBFOLDER As String 	= ""						' Folder for the database - empty is same folder as appdir
	Dim CTABLECLIENTE As String = "cfdicliente"				' SQL table holding contacts
	Dim CTABLECLIENTEFIELDSS As String = "ID, CODE, NAME, ADDRESS, ADRESS2, NOEXTER, NOINTER,COD,CITY,STATE"
	Private FListOfMaps As List				' List of maps used to insert/update clientes record into the database
	Private FTableViewColumnWidth As List	' List of columnswidth
	Dim TableviewClientes As TableView
	Private SQL As SQL
	Private txtCliente As TextField
	Private txtRfc As TextField
	Private txtNombre As TextField
	Private txtDom1 As TextField
	Private tabdatoscliente As TabPage
	Private tabestado As TabPage
	Private clientespane As AnchorPane
	Private tabclientedatos As TabPane
	Private toolbarclientes As Node
	Private photo As ImageView
End Sub

Public Sub Initialize (Parent As Form, title As String, info As String)
	frm.Initialize("frm", -1, -1)
	frm.title = title
	frm.SetFormStyle("UTILITY")
	frm.RootPane.LoadLayout("cfdiclientes")
	frm.SetOwner(Parent)
	DatePicker.Initialize("DatePicker")
	frm.RootPane.AddNode(DatePicker, 0, 0, 0, 0)
	frm.RootPane.SetAnchors(DatePicker, 250, 50, 0, 0)
	DatePicker.ShowTime = True ' Only in Single mode
	DatePicker.Mode =   "Single" ' also "Multiple" or "Range"
	DatePicker.Visible = False
	DateField.Initialize("DateField")
	DateField.TooltipText = "Seleccione Fecha para Reporte ó Teclee # en texto para Fecha actual"
	tabestado.Content.AddNode(DateField, 50, 100, 75, 0)
	TimeField.Initialize("TimeField")
	tabestado.Content.AddNode(TimeField, 50, 145, 0, 0)
	frm.RootPane.SetAnchors(DateField, 0, 10, -1, -1)
	frm.RootPane.SetAnchors(TimeField, 0, 45, -1, -1)
	TimeField.ShowLabels = True
	frm.Resizable = True
	DateTime.DateFormat = "dd.MM.YYYY"
	FListOfMaps.Initialize
	FTableViewColumnWidth.Initialize
	openDatabase
End Sub

' Show the form. A result can be set. In this case using an integer (my year of birth = just to test)
Public Sub Show As Int
	Dim ps As Screen = fx.PrimaryScreen
	Dim xsize=0dip As Int
    frm.WindowWidth = (ps.MaxX - ps.MinX)-xsize
    frm.WindowHeight = (ps.MaxY - ps.MinY)-xsize
	frm.ShowAndWait	
	Return 1958
End Sub

' Close the form
Private Sub frm_CloseRequest (EventData As Event)
	' Log("Form closed via close request")
End Sub

' Close
Private Sub buttonOK_Action
	frm.Close
End Sub
Sub cerrar_Action
	frm.Close
End Sub
Sub cfdimasterbtn_Action
	Dim message, title As String
	message = "CLICK CATALOGO DE ARCHIVOS"
	title = "TITULO CLICK CATALOGO DE ARCHIVOS"
	Dim msgf As cfdimaster
	msgf.Initialize(frm, title, message)
	msgf.Show
End Sub

Sub openDatabase
	AppLog("openDatabase :: " & "Start")
	SQL.InitializeSQLite(File.DirApp, CDBFOLDER & "/" & CFDIDATA, True)
	DbUtils.ExecuteTableView(SQL, "SELECT " & CTABLECLIENTEFIELDSS & " FROM " & CTABLECLIENTE, Null, 0, TableviewClientes)
	AppLog("TOTAL REGISTROS :: " & TableviewClientes.Items.Size)
	If TableviewClientes.Items.Size > 0 Then TableviewClientes.SelectedRow = 0
	AppLog("openDatabase :: " & "End")
End Sub
Sub AppLog(logentry As String)
	If CAPPLOG Then Log(logentry)
End Sub

Sub TableviewClientes_SelectedRowChanged(Index As Int, Row() As Object)
	If Index = -1 Then Return
	txtCliente.text 		= Row(1)
	txtNombre.text	= Row(2)
	txtRfc.text 	= Row(3)
	txtDom1.text 	= Row(4)
End Sub

